using System.Drawing;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        private ItemList itemList;
        private ImageList imageList;
        
        public Form1()
        {
            InitializeComponent();
            SetUpGrid();
            
            imageList = new ImageList();
            imageList.Images.Add(new Icon("c:\\edw\\WindowsApplication1\\WindowsApplication1\\Resources\\Icon1.ico"));
        }

        public void SetUpGrid()
        {
            grid.TableModel.Options.ActivateCurrentCellBehavior = GridCellActivateAction.SelectAll;
            grid.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(grid_QueryCellStyleInfo);
 
            itemList = new ItemList();

            itemList.Add(new Item(100, 500));
            itemList.Add(new Item(150, 100));
            itemList.Add(new Item(600, 1000));
            itemList.Add(new Item(500, 10));
            itemList.Add(new Item(501, 500));
            itemList.Add(new Item(25, 3000));
            itemList.Add(new Item(1000, 10000));
            itemList.Add(new Item(60, 50));
            itemList.Add(new Item(546, 100));
            itemList.Add(new Item(315, 5000));
            itemList.Add(new Item(284, 200));

            grid.DataSource = itemList;
        }

        private void grid_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            switch (e.TableCellIdentity.TableCellType)
            {
                case GridTableCellType.RecordFieldCell:
                case GridTableCellType.AlternateRecordFieldCell:
                    GridColumnDescriptor column = e.TableCellIdentity.Column;
                    if (column != null)
                    {
                        switch (column.Name)
                        {
                            case "Shares":

                                e.Style.ReadOnly = false;
                                e.Style.CellType = "Currency";
                                e.Style.CurrencyEdit.CurrencyDecimalDigits = 0;
                                e.Style.CurrencyEdit.CurrencySymbol = "";

                                object o = e.TableCellIdentity.DisplayElement.GetData();
                                if (o != null && o is Item)
                                {
                                    if (((Item)o).MaxSharesExceeded)
                                    {
                                        e.Style.BackColor = Color.Salmon;
                                        e.Style.ImageList = imageList;
                                        e.Style.ImageIndex = 0;
                                        e.Style.CellTipText = "max shares exceeded";
                                    }
                                }
                                break;
                            case "Text":
                            case "MaxShares":
                            case "MaxSharesExceeded":
                                e.Style.ReadOnly = true;
                                break;
                        }
                    }
                    break;
            }
        }
   }
}